<template>
  <el-row :gutter="20">
    <!-- 左侧部门树 -->
    <el-col :span="4" :xs="24">
      <ContentWrap class="h-1/1" v-if="treeShow">
        <DeptTree @node-click="handleDeptNodeClick" />
      </ContentWrap>
    </el-col>
    <el-col :span="contentSpan" :xs="24">
      <ContentWrap>
        <!-- 搜索工作栏 -->
        <el-form
          class="-mb-15px"
          :model="queryParams"
          ref="queryFormRef"
          :inline="true"
          label-width="68px"
        >
          <el-form-item :label="t('devicePerson.deviceCode')" prop="deviceCode" style="margin-left: 20px">
            <el-input
              v-model="queryParams.deviceCode"
              :placeholder="t('devicePerson.codeHolder')"
              clearable
              @keyup.enter="handleQuery"
              class="!w-200px"
            />
          </el-form-item>
          <el-form-item :label="t('devicePerson.deviceName')" prop="deviceName">
            <el-input
              v-model="queryParams.deviceName"
              :placeholder="t('devicePerson.nameHolder')"
              clearable
              @keyup.enter="handleQuery"
              class="!w-200px"
            />
          </el-form-item>

          <el-form-item :label="t('devicePerson.responsiblePerson')" prop="setFlag" label-width="140px">
            <el-select
              v-model="queryParams.setFlag"
              :placeholder="t('devicePerson.choose')"
              clearable
              class="!w-150px"
            >
              <el-option
                v-for="dict in resultOptions"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              />
            </el-select>
          </el-form-item>
          <el-form-item :label="t('devicePerson.rp')" prop="nickname">
            <el-input
              v-model="queryParams.nickname"
              :placeholder="t('devicePerson.nicknameHolder')"
              clearable
              @keyup.enter="handleQuery"
              class="!w-200px"
            />
          </el-form-item>

          <el-form-item>
            <el-button @click="handleQuery"
              ><Icon icon="ep:search" class="mr-5px" /> {{ t('devicePerson.search') }}</el-button
            >
            <el-button @click="resetQuery"
              ><Icon icon="ep:refresh" class="mr-5px" /> {{ t('devicePerson.reset') }}</el-button
            >
            <el-button
              type="primary"
              plain
              @click="openForm('create', undefined, queryParams.deptId)"
              v-hasPermi="['pms:iot-device-person-log:create']"
            >
              <Icon icon="ep:plus" class="mr-5px" /> {{ t('devicePerson.setUp') }}
            </el-button>
            <el-button
              type="success"
              plain
              @click="handleExport"
              :loading="exportLoading"
              v-hasPermi="['rq:iot-device:export']"
            >
              <Icon icon="ep:download" class="mr-5px" /> 导出
            </el-button>
          </el-form-item>
        </el-form>
      </ContentWrap>

      <!-- 列表 -->
      <ContentWrap>
        <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
          <el-table-column :label="t('monitor.serial')" width="70" align="center">
            <template #default="scope">
              {{ scope.$index + 1 }}
            </template>
          </el-table-column>
          <el-table-column :label="t('monitor.deviceCode')" align="center" prop="deviceCode" />
          <el-table-column :label="t('monitor.deviceName')" align="center" prop="deviceName">
            <template #default="scope">
              <el-link :underline="false" type="primary" @click="handleDetail(scope.row.id)">
                {{ scope.row.deviceName }}
              </el-link>
            </template>
          </el-table-column>
          <el-table-column :label="t('devicePerson.dept')" align="center" prop="deptName" />
          <el-table-column :label="t('devicePerson.rp')" align="center" prop="responsibleNames" />
          <el-table-column :label="t('devicePerson.operation')" align="center" min-width="120px">
            <template #default="scope">
              <el-button
                link
                type="primary"
                @click="handleView(scope.row.id)"
                v-hasPermi="['rq:iot-device:query']"
              >
                {{ t('devicePerson.adjustmentRecords') }}
              </el-button>
            </template>
          </el-table-column>
        </el-table>
        <!-- 分页 -->
        <Pagination
          :total="total"
          v-model:page="queryParams.pageNo"
          v-model:limit="queryParams.pageSize"
          @pagination="getList"
        />
      </ContentWrap>
    </el-col>
  </el-row>
  <DevicePersonLogDrawer
    :model-value="drawerVisible"
    @update:model-value="val => drawerVisible = val"
    :device-id="currentDeviceId"
    ref="showDrawer"
  />
</template>

<script setup lang="ts">
import download from '@/utils/download'
import { IotDeviceApi, IotDeviceVO } from '@/api/pms/device'
import { DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import DeptTree from '@/views/system/user/DeptTree.vue'
import { CACHE_KEY, useCache } from '@/hooks/web/useCache'
import DevicePersonLogDrawer from "@/views/pms/device/personlog/DevicePersonLogDrawer.vue";

/** 设备台账 列表 */
defineOptions({ name: 'IotDevicePerson' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化
const { push } = useRouter() // 路由跳转

const loading = ref(true) // 列表的加载中
const ifShow = ref(false)
const list = ref<IotDeviceVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  deviceCode: undefined,
  deviceName: undefined,
  brand: undefined,
  model: undefined,
  deptId: undefined,
  deviceStatus: undefined,
  assetProperty: undefined,
  picUrl: undefined,
  remark: undefined,
  manufacturerId: undefined,
  supplierId: undefined,
  manDate: [],
  nameplate: undefined,
  expires: undefined,
  plPrice: undefined,
  plDate: [],
  plYear: undefined,
  plStartDate: [],
  plMonthed: undefined,
  plAmounted: undefined,
  remainAmount: undefined,
  infoId: undefined,
  infoType: undefined,
  infoName: undefined,
  infoRemark: undefined,
  infoUrl: undefined,
  templateJson: undefined,
  creator: undefined,
  setFlag: '',
  nickname: ''
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中
const contentSpan = ref(20)
const treeShow = ref(true)

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await IotDeviceApi.responsiblePage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 处理部门被点击 */
const handleDeptNodeClick = async (row) => {
  queryParams.deptId = row.id
  await getList()
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}
const moreQuery = (show) => {
  ifShow.value = show
}
/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  //修改
  if (typeof id === 'number') {
    push({ name: 'DeviceDetailEdit', params: { id } })
    return
  }
  // 新增
  push({ name: 'ConfigDevicePerson', params: {} })
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await IotDeviceApi.deleteIotDevice(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

// 是否设置过责任人 下拉列表 模拟字典项
const resultOptions = computed(() => [
  {
    label: '全部',
    value: 'A' // 空值会触发 clearable 效果
  },
  {
    label: '是',
    value: 'Y' // 空值会触发 clearable 效果
  },
  {
    label: '否',
    value: 'N' // 空值会触发 clearable 效果
  },
])

const handleDetail = (id: number) => {
  push({ name: 'DeviceDetailInfo', params: { id } })
}

/** 查看设备责任人调整详情 */
const currentDeviceId = ref() // 设备id
const drawerVisible = ref<boolean>(false)
const showDrawer = ref()

const handleView = async (deviceId: number) => {
  currentDeviceId.value = deviceId
  drawerVisible.value = true
  // 强制重新加载数据
  nextTick(() => {
    showDrawer.value?.loadDevicePersons(deviceId)
  })
  showDrawer.value.openDrawer()
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await IotDeviceApi.exportIotDevice(queryParams)
    download.excel(data, '设备台账.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}
const { wsCache } = useCache()
/** 初始化 **/
onMounted(() => {
  const user = wsCache.get(CACHE_KEY.USER)
  // queryParams.deptId = user.user.deptId
  getList()
})
</script>
<style scoped></style>
